#pragma once

#include "UtilTypes.h"
#include "AnyPointer.h"
#ifdef _WIN32
	#include <Windows.h>
#endif

class Module {
public:
	Module();
	Module(AnyPointer insideAddress);
	~Module();
	void Open(AnyPointer insideAddress);
	void Close();
	bool IsOpened() const;
	AnyPointer FindSymbol(const char *symbolName) const;
private:
#ifdef _WIN32
	typedef HMODULE Handle;
#elif defined __linux__
	typedef void* Handle;
#endif
	static const Handle INVALID_HANDLE;

	Handle m_handle;
	uintptr_t m_baseAddress;
};